//---------------------------------------------------------------------------

#ifndef smcH
#define smcH
//---------------------------------------------------------------------------
#include <vector>

#define COUNT(a) (sizeof(a)/sizeof((a)[0]))

#pragma pack(push,1) // byte align
typedef struct{
   unsigned char bg[24][3][10];
   unsigned char fg[24][3][10];
   unsigned char md[24][3][10];
   unsigned char block_gg[256];
   unsigned char block_fg[256];
   unsigned char block_ob[256];
   unsigned char block_fl[256];
   unsigned char rm_links[24][4];
   unsigned char start_rm,start_ps,start_dr,zero;
   unsigned char guard_ps[24];
   unsigned char guard_tp[24];
   unsigned char guard_sk[24];
   unsigned char guard_uk1[24];
   unsigned char guard_uk2[24];
   unsigned char guard_uk3[24];
   unsigned char door1[256];
   unsigned char door2[256];
}TLevel;
#if sizeof(TLevel)!=3940
#error Level size incorrect!
#endif
#pragma pack(pop)
class TSMC {
   private:
   TMemoryStream* ms_smc;
   TMemoryStream** ms_data; int ndata;
   int SMCHD;
   public:
   int curr_level,curr_rm;
   int ltype,otype;
   bool want_label;
   unsigned __int16* bgblock;
   unsigned char* bgtile;
   unsigned __int16* fgblock;
   unsigned char* fgtile;
   unsigned __int16* ggblock;
   unsigned char* ggtile;
   TColor* pal,*pal2;
   bool sel[3][10];
   TLevel level;
   TSMC();
   ~TSMC();
   bool opensmc(AnsiString);
   void clear();
   void openlevel();
   void decodelevel(TMemoryStream*,TMemoryStream*,int);
   void openenv(int);
   void decodeenv(TMemoryStream*,unsigned __int16**,unsigned char**,int,int,int,int,int,int,int);
   void decodearray(TMemoryStream*,int,int,unsigned __int16*);
   void decodeblock(TMemoryStream*,int,int,unsigned __int16*);
   void decodetile16(TMemoryStream*,int,unsigned char*);
   void decodetile32(TMemoryStream*,int,unsigned char*);
   void drawroom(Graphics::TBitmap*);
   void drawlayer(Graphics::TBitmap*,unsigned char[3][10],int,int,int,unsigned __int16*,unsigned char*,unsigned char*,unsigned char,unsigned char*);
   void drawblock(Graphics::TBitmap*,int,int,int,int,int,int,unsigned __int16*,unsigned char*,unsigned char,bool);
   void drawtile(Graphics::TBitmap*,int,int,int,int,unsigned char*,unsigned char,bool);
   void decodepal(TMemoryStream*,TColor**,int);
   void brightpal(TColor*,TColor*/***/,int);
   void clearsel();
   void savelevel();
   void savesmc(AnsiString);
   void encodelevel(TMemoryStream*,TMemoryStream*,int);
//   unsigned __int32 lastsa;
   void decodesprite(TMemoryStream*,unsigned char**,unsigned char*,unsigned char*,unsigned char*,unsigned char*);
   void drawsprite(Graphics::TBitmap*,int,int,int,int,bool,bool);
   void decodeobj(TMemoryStream* ms_in,unsigned char**tile);
   void drawobj(Graphics::TBitmap* bm,int x0,int y0,int ix,bool sel);
   void drawanobj(Graphics::TBitmap* bm,int x0,int y0,unsigned char ch,bool sel);
   void drawtorch(Graphics::TBitmap* bm,int x0,int y0,bool sel);
   void closeenv();
   void* getaddr(int addr);
   void set_ltype(int level,int lt);
   void editenvpal();
   void editpal(int index,AnsiString pt);
   void encodepal(TMemoryStream*,TColor*,int);
   void editspritespal();
};
extern const char* ob[0x2C];
extern const char* gu[0x19];
extern const char* levels[0x1B];
extern const char* ltypes[10];

#endif
